<?php
/* =====================================================================
 * Dieses Skript ist Teil von "Wetter-Analyse in Dekaden (WADE)"
 * Von "Trixi aus Witten/NRW" - http://taw-wade.kilu.de/
 *                 Version 19.05.01 - Build 23.05.2019
 * Lizenziert unter "Namensnennung-Weitergabe unter gleichen Bedingungen
 * 3.0 Deutschland (CC BY-SA 3.0)"
 *                 ==> http://creativecommons.org/licenses/by-sa/3.0/de/
 *
 * Diese Software ist FREIE SOFTWARE und wird mit der Hoffnung, daß sie
 * nützlich sein könnte, zur Verfügung gestellt, jedoch OHNE JEDE
 * GEWÄHRLEISTUNG. Auch nicht für eine ALLGEMEINE GEBRAUCHSTAUGLICHKEIT
 * oder Stabilität für die NUTZUNG ZU EINEM BESTIMMTEN ZWECK. Die freie
 * Software, von der hier die Rede sein soll, ist kein "Freibier",
 * sondern sie gibt dir die Freiheiten
 *
 *   o  die Software für einen beliebigen Zweck auszuführen
 *   o  die Funktionsweise der Software zu studieren und sie an deine
 *      eigenen Bedürfnisse anzupassen
 *   o  Kopien der Software weiterzugeben
 *   o  sowie die Software zu verbessern und diese Verbesserungen zu
 *      veröffentlichen.
*/
// @module hitliste "\t\tErmittelt eine Rangliste nach sortiert Jahren bei\n\t\t\tdenen die Bedingungen zutreffen\n"
$DA->KonsolenAusgabe('Beginne mit der Ausführung von '.basename(__FILE__),1);
	if ( !is_dir($einstellungen['zwischenspeicher']['speicher_pfad']) )
	$DA->KonsolenAusgabe('Das Verzeichnis für den Zwischenspeicher existiert nicht',-1);
	if ( strlen($DA->cli_parameter['station']) < 4 )
	$DA->KonsolenAusgabe('Es wurde keine Station mit "--station=[name]" angegeben',-1);
	if ( !isset($einstellungen['daten'][$DA->cli_parameter['station']]) )
	$DA->KonsolenAusgabe('Diese Station befindet sich nicht in der Konfiguration',-1);
	if ( !in_array($einstellungen['hitliste']['datenreihe_auswerten'],$DA->datenreihen) )
	$DA->KonsolenAusgabe('Es existiert keine Datenreihe mit dem Namen "'.$einstellungen['hitliste']['datenreihe_auswerten'].'"',-1);
	if ( $DA->cli_parameter['vergleich'] === '' )
	$DA->KonsolenAusgabe('Es wurde kein Vergleichszeitraum mit "--vergleich=[jahre]" angegeben',-1);

$DA->KonsolenAusgabe('Berechne die Daten für die Hitliste',2);
$datensatz = $DA->HoleRoheDatenDerJahre($DA->cli_parameter['station'],$DA->cli_parameter['vergleich']);
$dekaden_auswahl = $DA->ErmittleDekadenAuswahl('hitliste');
$daten_temp = array();

	foreach ( $datensatz as $daten ){
	$dekade = $DA->ErmittleDekade($daten['tag']);
	$schluessel = $daten['monat'].'/'.$dekade;
		if ( in_array($schluessel,$dekaden_auswahl) ){
			if ( !isset($daten_temp[$daten['jahr']]) )
			$daten_temp[$daten['jahr']] = array();
		$daten_temp[$daten['jahr']][] = $daten[$einstellungen['hitliste']['datenreihe_auswerten']];
		}
	}

$DA->KonsolenAusgabe('Konsolidiere die Daten der Jahre mit "'.$einstellungen['hitliste']['konsolidierung_funktion'].'"',2);
$hitliste = array();

	foreach ( $daten_temp as $jahr=>$werte ){
	$DA->UngueltigeDatensaetzeEntfernen($werte,sprintf('%04d::%s',$jahr,$einstellungen['hitliste']['datenreihe_auswerten']));
		switch ( strtolower($einstellungen['hitliste']['konsolidierung_funktion']) ){
		case 'mittelwert':
		$hitliste[$jahr] = array_sum($werte)/sizeof($werte);
		break;
		case 'summe':
		$hitliste[$jahr] = array_sum($werte);
		break;
		}
	}

$DA->KonsolenAusgabe('Sortiere die Ergebnisse der Hitliste',2);

	if ( $einstellungen['hitliste']['ergebnis_sortieren'] === 'aufsteigend' )
	asort($hitliste);
	elseif ( $einstellungen['hitliste']['ergebnis_sortieren'] === 'absteigend' )
	arsort($hitliste);

$DA->KonsolenAusgabe('Datenbearbeitung beendet',1);
$DA->KonsolenAusgabe('Erstellen des Reports vom Typ '.$DA->cli_parameter['typ'],1);
define('LF',"\r\n"); // \r\n für bessere Lesbarkeit unter Windows beim Standardeditor
$report = '';

	switch ( $DA->cli_parameter['typ'] ){
	case 'text':
	$report .= str_repeat('=',72).LF;
	$report .= 'HITLISTE FÜR DEN ZEITRAUM DER JAHRE '.$DA->cli_parameter['vergleich'].LF;
	$report .= 'Erstellt am '.strftime(WADE_FDATE,time()).LF;
	$report .= 'Name der Station: '.$einstellungen['daten'][$DA->cli_parameter['station']]['name'].
		' ('.$einstellungen['daten'][$DA->cli_parameter['station']]['code'].')'.LF;
	$report .= 'Daten-Quelle: '.$einstellungen['daten'][$DA->cli_parameter['station']]['quelle'].LF.LF;
	$report .= 'Die Werte für "'.$einstellungen['hitliste']['datenreihe_auswerten'].'" in den Dekaden "'.$einstellungen['hitliste']['dekaden_auswahl'].
		'" wurde mit "'.$einstellungen['hitliste']['konsolidierung_funktion'].'" zusammengerechnet'.LF.LF;
		if ( !empty($einstellungen['hitliste']['kommentar']) )
		$report .= $einstellungen['hitliste']['kommentar'].LF.LF;
	$a = 1;
		foreach ( $hitliste as $jahr=>$wert ){
			if ( $a > (int)$einstellungen['hitliste']['ergebnis_anzahl'] )
			break;
		$report .= chr(9).str_pad($a,strlen((int)$einstellungen['hitliste']['ergebnis_anzahl']),' ',STR_PAD_LEFT).'.'.chr(9).number_format($wert,1).' ('.$jahr.')'.LF;
		$a++;
		}
	$report .= LF.LF;
		if ( strlen($einstellungen['report']['lizenz_text']) > 20 )
		$report .= $einstellungen['report']['lizenz_text'];
		if ( strlen($einstellungen['report']['lizenz_uri']) > 8 )
		$report .= LF.$einstellungen['report']['lizenz_uri'].LF.LF;
	break;

	case 'html':
	$report .= '<!DOCTYPE html>'.LF;
	$report .= '<html>'.LF;
	$report .= '<head>'.LF;
	$report .= '<meta http-equiv="content-type" content="text/html;charset=utf-8"></meta>'.LF;
	$report .= '<body>'.LF;
	$report .= '<h1>HITLISTE FÜR DEN ZEITRAUM DER JAHRE '.htmlspecialchars($DA->cli_parameter['vergleich']).'</h1>'.LF;
	$report .= '<p>Erstellt am '.strftime(WADE_FDATE,time()).'<br />'.LF;
	$report .= 'Name der Station: '.htmlspecialchars($einstellungen['daten'][$DA->cli_parameter['station']]['name']).
		' ('.htmlspecialchars($einstellungen['daten'][$DA->cli_parameter['station']]['code']).')<br />'.LF;
	$report .= 'Daten-Quelle: '.htmlspecialchars($einstellungen['daten'][$DA->cli_parameter['station']]['quelle']).'<br /><br />'.LF;
	$report .= 'Die Werte für "'.htmlspecialchars($einstellungen['hitliste']['datenreihe_auswerten']).'" in den Dekaden "'.htmlspecialchars($einstellungen['hitliste']['dekaden_auswahl']).
		'" wurde mit "'.htmlspecialchars($einstellungen['hitliste']['konsolidierung_funktion']).'" zusammengerechnet</p>'.LF.LF;
		if ( !empty($einstellungen['hitliste']['kommentar']) )
		$report .= '<p>'.$einstellungen['hitliste']['kommentar'].'</p>'.LF;
	$a = 1;
	$report .= '<ol type="1">'.LF;
		foreach ( $hitliste as $jahr=>$wert ){
			if ( $a > (int)$einstellungen['hitliste']['ergebnis_anzahl'] )
			break;
		$report .= '<li>'.number_format($wert,1).' ('.$jahr.')</li>'.LF;
		$a++;
		}
	$report .= '/<ol>'.LF;
		if ( strlen($einstellungen['report']['lizenz_text']) > 20 ){
			if ( strlen($einstellungen['report']['lizenz_uri']) > 8 )
			$report .= '<a href="'.$einstellungen['report']['lizenz_uri'].'" target="_blank">'.htmlspecialchars($einstellungen['report']['lizenz_text']).'</a>'.LF;
			else
			$report .= htmlspecialchars($einstellungen['report']['lizenz_text']).LF;
		}
	$report .= '</body>'.LF;
	$report .= '</html>';
	break;

	case 'xml':
	$report .= '<?xml version="1.0" encoding="utf-8" standalone="yes"?>'.LF;
	$report .= '<rekorde>'.LF;
		if ( !empty($einstellungen['hitliste']['kommentar']) )
		$report .= '/* '.$einstellungen['hitliste']['kommentar'].' */'.LF;
	$report .= '<meta>'.LF;
	$report .= chr(9).'<erstelltam>'.strftime(WADE_FDATE,time()).'</erstelltam>'.LF;
	$report .= chr(9).'<zeitraum>'.htmlspecialchars($DA->cli_parameter['vergleich']).'</zeitraum>'.LF;
	$report .= chr(9).'<name>'.htmlspecialchars($einstellungen['daten'][$DA->cli_parameter['station']]['name']).'</name>'.LF;
	$report .= chr(9).'<code>'.htmlspecialchars($einstellungen['daten'][$DA->cli_parameter['station']]['code']).'</code>'.LF;
	$report .= chr(9).'<datenquelle>'.htmlspecialchars($einstellungen['daten'][$DA->cli_parameter['station']]['quelle']).'</datenquelle>'.LF;
	$report .= chr(9).'<datenreihe>'.htmlspecialchars($einstellungen['hitliste']['datenreihe_auswerten']).'</datenreihe>'.LF;
	$report .= chr(9).'<dekaden>'.htmlspecialchars($einstellungen['hitliste']['dekaden_auswahl']).'</dekaden>'.LF;
	$report .= chr(9).'<konsolidierung>'.htmlspecialchars($einstellungen['hitliste']['konsolidierung_funktion']).'</konsolidierung>'.LF;
	$report .= '</meta>'.LF;
	$report .= '<lizenz>'.LF;
	$report .= chr(9).'<name>'.htmlspecialchars($einstellungen['report']['lizenz_text']).'</name>'.LF;
	$report .= chr(9).'<uri>'.$einstellungen['report']['lizenz_uri'].'</uri>'.LF;
	$report .= '</lizenz>'.LF;
	$report .= '<daten>'.LF;
	$a = 1;
		foreach ( $hitliste as $jahr=>$wert ){
			if ( $a > (int)$einstellungen['hitliste']['ergebnis_anzahl'] )
			break;
		$report .= chr(9).'<datensatz>'.LF;
		$report .= chr(9).chr(9).'<jahr>'.$jahr.'</jahr>'.LF;
		$report .= chr(9).chr(9).'<wert>'.$wert.'</wert>'.LF;
		$report .= chr(9).'</datensatz>'.LF;
		$a++;
		}
	$report .= '</daten>'.LF;
	$report .= '</rekorde>';
	break;
	}

	if ( $DA->cli_parameter['report_auf_standard_ausgabe'] )
	print_r($report);
	elseif ( !empty($einstellungen['report']['ausgabe_datei_maske']) && is_writeable(dirname($einstellungen['report']['ausgabe_datei_maske'])) )
	file_put_contents($einstellungen['report']['ausgabe_datei_maske'],$report);
$DA->KonsolenAusgabe('Report erstellt in "'.$einstellungen['report']['ausgabe_datei_maske'].'"',1);
$DA->KonsolenAusgabe('Aufgaben erledigt. Ciao!',0);
?>
