<?php
/* =====================================================================
 * Dieses Skript ist Teil von "Wetter-Analyse in Dekaden (WADE)"
 * Von "Trixi aus Witten/NRW" - http://taw-wade.kilu.de/
 *                 Version 19.05.01 - Build 23.05.2019
 * Lizenziert unter "Namensnennung-Weitergabe unter gleichen Bedingungen
 * 3.0 Deutschland (CC BY-SA 3.0)"
 *                 ==> http://creativecommons.org/licenses/by-sa/3.0/de/
 *
 * Diese Software ist FREIE SOFTWARE und wird mit der Hoffnung, daß sie
 * nützlich sein könnte, zur Verfügung gestellt, jedoch OHNE JEDE
 * GEWÄHRLEISTUNG. Auch nicht für eine ALLGEMEINE GEBRAUCHSTAUGLICHKEIT
 * oder Stabilität für die NUTZUNG ZU EINEM BESTIMMTEN ZWECK. Die freie
 * Software, von der hier die Rede sein soll, ist kein "Freibier",
 * sondern sie gibt dir die Freiheiten
 *
 *   o  die Software für einen beliebigen Zweck auszuführen
 *   o  die Funktionsweise der Software zu studieren und sie an deine
 *      eigenen Bedürfnisse anzupassen
 *   o  Kopien der Software weiterzugeben
 *   o  sowie die Software zu verbessern und diese Verbesserungen zu
 *      veröffentlichen.
*/
	function WADE_Nur_Verfuegbare_Module(&$verfuegbar,$moeglich){
	$moeglich = explode(',',$moeglich);
		foreach ( $moeglich as $schluessel=>$wert ){
			if ( !in_array($wert,$verfuegbar,true) )
			unset($moeglich[$schluessel]);
		}
		if ( sizeof($moeglich) > 0 )
		return '(nur '.implode(',',$moeglich).')';
		else
		return '';
	}

class Dekaden_Analyse {
protected $attribute_parser = 'text-substr';
protected $svg_stilvorlagen = false;
protected $nutze_optimierungen = true; // Zwischenspeicher (Sonnenschein und Klimamittel)
protected $niederschlagsgrenze_fuer_regentag_in_mm = 0.1; // nach DWD-Definition
public $cli_parameter = array(
	'psst_still_sein'=>false,
	'debug_ausgabe'=>0,
	'update_download'=>false,
	'update_install'=>false,
	'report_auf_standard_ausgabe'=>false,
	'konfiguration'=>'~/benutzer_beispiel.ini',
	'aktion'=>'',
	'station'=>'',
	'vergleich'=>'',
	'jahr'=>0,
	'typ'=>'text',
	'bedingung'=>'',
	'benutzer1'=>'',
	'benutzer2'=>'',
	'benutzer3'=>'',
	'benutzer4'=>''
	);
public $datenreihen = array(
	'temperatur_max',
	'temperatur_mit',
	'temperatur_min',
	'luftdruck_mit',
	'feuchte_mit',
	'wind_mit',
	'sonne',
	'niederschlag',
	'schneehoehe',
/*	'wolken_6h',
	'wolken_12h',
	'wolken_18h',*/
	'wolken_mit',
	'%tropentag',
	'%sommertag',
	'%frosttag',
	'%eistag',
	'%tropennacht',
	'%mildnacht',
	'%regentag',
	'%schneetag',
	'%sonnenschein'
);
public $grundgeruest_werte = array();
public $grundgeruest_dekaden = array();
public $startzeit = 0;

	public function __construct(){
	global $einstellungen;
		foreach ( $this->datenreihen as $d )
		$this->grundgeruest_werte[$d] = 0;
		for ( $m = 1 ; $m <= 12 ; $m++ ){
			for ( $d = 1 ; $d <= 3 ; $d++ )
			$this->grundgeruest_dekaden[$m.'/'.$d] = $this->grundgeruest_werte;
		}
	$this->startzeit = microtime(true);
	$this->BearbeiteKommandozeilenParameter($GLOBALS['argv']);
	$makro = array('~/','%station%','%jahr%','%typ%','%aktion%','%benutzer1%','%benutzer2%','%benutzer3%','%benutzer4%','%paramhash%');
	$ersetzen = array(dirname(__FILE__).'/',$this->cli_parameter['station'],$this->cli_parameter['jahr'],
		$this->cli_parameter['typ'],$this->cli_parameter['aktion'],
		$this->cli_parameter['benutzer1'],$this->cli_parameter['benutzer2'],$this->cli_parameter['benutzer3'],$this->cli_parameter['benutzer4'],
		sprintf('%u',crc32(print_r($this->cli_parameter,true))));
	$this->cli_parameter['konfiguration'] = str_replace($makro,$ersetzen,$this->cli_parameter['konfiguration']);
	$this->LadeBenutzerdefinierteEinstellungen($einstellungen);
	$einstellungen['report']['ausgabe_datei_maske'] = str_replace($makro,$ersetzen,$einstellungen['report']['ausgabe_datei_maske']);
	$einstellungen['grafik']['ausgabe_datei_maske'] = str_replace($makro,$ersetzen,$einstellungen['grafik']['ausgabe_datei_maske']);
	$einstellungen['zwischenspeicher']['speicher_pfad'] = str_replace($makro,$ersetzen,$einstellungen['zwischenspeicher']['speicher_pfad']);
		if ( $einstellungen['rekorde']['monate_anzeigen'] === '*' )
		$einstellungen['rekorde']['monate_anzeigen'] = '1,2,3,4,5,6,7,8,9,10,11,12';
		if ( $einstellungen['wieselflink']['monate_anzeigen'] === '*' )
		$einstellungen['wieselflink']['monate_anzeigen'] = '1,2,3,4,5,6,7,8,9,10,11,12';
	$einstellungen['grafik']['diagramm_abstand'] = 50; // TODO: zur Zeit noch hart kodiert
	return true;
	}

	public function BearbeiteKommandozeilenParameter($parameter){
		if ( !is_array($parameter) )
		return false;
		foreach ( $parameter as $v ){
			if ( substr($v,0,1) === '-' && substr($v,1,1) === 'q' )
			$this->cli_parameter['psst_still_sein'] = true;
			if ( substr($v,0,1) === '-' && substr($v,1,1) === 'v' )
			$this->cli_parameter['debug_ausgabe'] = substr_count($v,'v');
			if ( substr($v,0,1) === '-' && substr($v,1,1) === 'd' )
			$this->cli_parameter['update_download'] = true;
			if ( substr($v,0,1) === '-' && substr($v,1,1) === 'i' )
			$this->cli_parameter['update_install'] = true;
			if ( substr($v,0,1) === '-' && substr($v,1,1) === 'o' )
			$this->cli_parameter['report_auf_standard_ausgabe'] = true;
			if ( substr($v,0,2) === '--' ){
			$v = explode('=',$v);
			$k = substr($v[0],2);
			unset($v[0]);
			$v = implode('=',$v);
				switch ( $k ){
				case 'dry-run':
				define('HEY_DONT_YOU_CHANGE_DATA','true');
				break;
				case 'station':
				$this->cli_parameter['station'] = preg_replace('/[^a-z]+/i','',$v);
				break;
				case 'vergleich':
				$this->cli_parameter['vergleich'] = preg_replace('/[^0-9,\-\*]+/','',$v);
					if ( $this->cli_parameter['vergleich'] === '*' )
					$this->cli_parameter['vergleich'] = '1700-'.date('Y',mktime(0,0,0,1,1,date('Y')-1));
				break;
				case 'jahr':
				$this->cli_parameter['jahr'] = intval($v);
				break;
				case 'typ':
				$this->cli_parameter['typ'] = ( in_array($v,array('text','csv','html','xml','abweichung','mittel','absolut'),true) || is_numeric($v) ) ? $v : 'text';
				break;
				case 'bedingung':
				$this->cli_parameter['bedingung'] = preg_replace('/[^a-z0-9_\-<>=\. ]+/i','',$v);
				break;
				case 'konfiguration':
				$this->cli_parameter['konfiguration'] = 'file://'.preg_replace('/[^a-z0-9_\/\.~]+/i','',$v);
				break;
				case 'benutzer1':
				$this->cli_parameter['benutzer1'] = preg_replace('/[^a-z0-9_\/\.]+/i','',$v);
				break;
				case 'benutzer2':
				$this->cli_parameter['benutzer2'] = preg_replace('/[^a-z0-9_\/\.]+/i','',$v);
				break;
				case 'benutzer3':
				$this->cli_parameter['benutzer3'] = preg_replace('/[^a-z0-9_\/\.]+/i','',$v);
				break;
				case 'benutzer4':
				$this->cli_parameter['benutzer4'] = preg_replace('/[^a-z0-9_\/\.]+/i','',$v);
				break;
				default:
				$this->cli_parameter['aktion'] = $k;
				break;
				}
			}
		}
		if ( $this->cli_parameter['psst_still_sein'] ){
		$this->cli_parameter['debug_ausgabe'] = 0;
		error_reporting(0);
		}
	return true;
	}

	protected function LadeBenutzerdefinierteEinstellungen(&$einstellungen){
	$this->KonsolenAusgabe(__FUNCTION__.'()',3);
		if ( file_exists($this->cli_parameter['konfiguration']) ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Datei "'.$this->cli_parameter['konfiguration'].'" gefunden',3);
		$roh = parse_ini_file($this->cli_parameter['konfiguration']);
			foreach ( $roh as $schluessel=>$wert ){
			$teile = explode('.',$schluessel);
				switch ( sizeof($teile) ){
				case 2:
					if ( isset($einstellungen[$teile[0]][$teile[1]]) ){
					$wert = $this->BenutzerWertPruefen($einstellungen[$teile[0]][$teile[1]],$wert);
						if ( $wert !== null ){
						$this->KonsolenAusgabe(__FUNCTION__.'() Konfigurationswert "'.$schluessel.'" auf "'.$this->VariablenInhaltLesbarAusgeben($wert).'" geändert',2);
							if ( $wert === '(unset)' )
							unset($einstellungen[$teile[0]][$teile[1]]);
							else
							$einstellungen[$teile[0]][$teile[1]] = $wert;
						}
					}
				break;
				case 3:
					if ( isset($einstellungen[$teile[0]][$teile[1]][$teile[2]]) ){
					$wert = $this->BenutzerWertPruefen($einstellungen[$teile[0]][$teile[1]][$teile[2]],$wert);
						if ( $wert !== null ){
						$this->KonsolenAusgabe(__FUNCTION__.'() Konfigurationswert "'.$schluessel.'" auf "'.$this->VariablenInhaltLesbarAusgeben($wert).'" geändert',2);
							if ( $wert === '(unset)' )
							unset($einstellungen[$teile[0]][$teile[1]][$teile[2]]);
							else
							$einstellungen[$teile[0]][$teile[1]][$teile[2]] = $wert;
						}
					}
				break;
				case 4:
					if ( isset($einstellungen[$teile[0]][$teile[1]][$teile[2]][$teile[3]]) ){
					$wert = $this->BenutzerWertPruefen($einstellungen[$teile[0]][$teile[1]][$teile[2]][$teile[3]],$wert);
						if ( $wert !== null ){
						$this->KonsolenAusgabe(__FUNCTION__.'() Konfigurationswert "'.$schluessel.'" auf "'.$this->VariablenInhaltLesbarAusgeben($wert).'" geändert',2);
							if ( $wert === '(unset)' )
							unset($einstellungen[$teile[0]][$teile[1]][$teile[2]][$teile[3]]);
							else
							$einstellungen[$teile[0]][$teile[1]][$teile[2]][$teile[3]] = $wert;
						}
					}
				break;
				}
			}
		}
		else
		return false;
	return true;
	}

	protected function BenutzerWertPruefen($alt,$neu){
		switch ( gettype($alt) ){
		case 'boolean':
		$neu = ( in_array($neu,array('true','yes','ja','on','an','1')) ) ? true : false;
		break;
		case 'integer':
		$neu = intval($neu);
		break;
		case 'string':
		// nix tun, string einfach weitergeben
		break;
		default:
		$neu = null;
		break;
		}
	return $neu;
	}

	protected function VariablenInhaltLesbarAusgeben($variable){
	$lesbar = '';
		switch ( gettype($variable) ){
		case 'boolean':
			if ( $variable === true )
			$lesbar = 'boolean:{true}';
			else
			$lesbar = 'boolean:{false}';
		break;
		case 'array':
		$lesbar = 'array:{'.SchluesselWertNachString($variable).'}';
		break;
		case 'integer': case 'double':
		$lesbar = 'numeric:{'.$variable.'}';
		break;
		default:
		$lesbar = 'string:{'.$variable.'}';
		break;
		}
	return $lesbar;
	}

	protected function AttributeZeichenketteVerarbeiten($attribute){
		switch ( $this->attribute_parser ){
		case 'pcre-split':
		$geteilt = preg_split('/(,)(?=(?:[^"]|"[^"]*")*$)/',$attribute);
		$attribute = array();
			foreach ( $geteilt as $wert ){
			$trenner = strpos($wert,'=');
				if ( $trenner > -1 ){
				$schluessel = substr($wert,0,$trenner);
				$wert = substr($wert,$trenner1);
				$attribute[$schluessel] = $wert;
				}
			}
		break;
		case 'text-substr':
		$roh = $attribute;
		$attribute = array();
		$puffer_schluessel = '';
		$puffer_wert = '';
		$geschuetzt = false;
		$als_wert = false;
			for ( $i = 0 ; $i <= strlen($roh) ; $i++ ){
			$zeichen = substr($roh,$i,1);
				if ( $als_wert ){
				$puffer_wert .= $zeichen;
					if ( $zeichen === '"' ){
						if ( $geschuetzt )
						$geschuetzt = false;
						else
						$geschuetzt = true;
					}
				}
				else{
					if ( $zeichen !== '=' )
					$puffer_schluessel .= $zeichen;
					else
					$als_wert = true;
				}
				if ( $zeichen === ',' && !$geschuetzt ){
				$attribute[$puffer_schluessel] = substr($puffer_wert,0,-1);
				$puffer_schluessel = '';
				$puffer_wert = '';
				$als_wert = false;
				$geschuetzt = false;
				}
			}
		break;
		default:
		parse_str(str_replace(array(',','+'),array('&','%2B'),$attribute),$attribute);
		break;
		}
	return $attribute;
	}

	protected function VektorGrafikStilvorlagenErzeugen(){
	global $einstellungen;
	$this->svg_stilvorlagen = array(
	'kopf-ueberschrift text'=>'font-family:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftart_ueberschrift']).';font-size:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftgroesse_ueberschrift_gross']).';',
	'kopf-info text'=>'font-family:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftart_ueberschrift']).';font-size:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftgroesse_ueberschrift_klein']).';',
	'fuss text'=>'font-family:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftart_normal']).';font-size:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftgroesse_normal']).';opacity:0.75;',
	'legende rect'=>'stroke:black;stroke-width:1px;',
	'legende text'=>'font-family:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftart_normal']).';font-size:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftgroesse_normal']).';',
	'legende-zusatz text'=>'font-family:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftart_normal']).';font-size:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftgroesse_normal']).';',
	'y-achse-aussen line'=>'stroke:black;stroke-width:1px;',
	'y-achse-aussen text'=>'font-family:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftart_normal']).';font-size:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftgroesse_y_achse']).';',
	'y-achse-innen line'=>'stroke:gray;stroke-width:0.25px;',
	'y-achse-innen line.dick'=>'stroke:black;stroke-width:0.75px;',
	'y-achse-innen line.nullinie'=>'stroke:black;stroke-width:3px;',
	'x-achse-aussen line'=>'stroke:black;stroke-width:1px;',
	'x-achse-aussen text'=>'font-family:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftart_normal']).';',
	'x-achse-aussen text.gross'=>'font-size:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftgroesse_x_achse_gross']).';',
	'x-achse-aussen text.klein'=>'font-size:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftgroesse_x_achse_klein']).';',
	'x-achse-innen line'=>'stroke:black;stroke-width:1px;',
	'x-achse-innen line.dick'=>'stroke:black;stroke-width:1px;',
	'diagramm-balken rect'=>'stroke:black;stroke-width:0.5px;',
	'diagramm-balken circle'=>'stroke:black;stroke-width:0.5px;',
	'diagramm-werte-zeigen rect'=>'stroke:none;opacity:0.33;',
	'diagramm-werte text'=>'font-family:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftart_festbreite']).';font-size:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftgroesse_werte_zeigen']).';',
	'dynamisch text'=>'font-family:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftart_festbreite']).';font-size:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftgroesse_gross']).';',
	);
		// TODO: Das könnte man erkennen lassen, wenn class=%IRGENDEINERKENNUNGSZEICHEN%cfillX
		// und dann entsprechend in VektorGrafikPuffer() dynamisch als "class" hinzufügen
		foreach ( $einstellungen['grafik']['diagramm_balken_daten'] as $balken_schluessel=>$balken_name ){
		$balken_name = explode(',',$balken_name);
		$this->svg_stilvorlagen['legende rect.cfill'.$balken_schluessel] = 'fill:'.$this->VektorGrafikCSSSaeubern($balken_name[1]).';';
		$this->svg_stilvorlagen['diagramm-balken circle.cfill'.$balken_schluessel] = 'fill:'.$this->VektorGrafikCSSSaeubern($balken_name[1]).';';
		$this->svg_stilvorlagen['diagramm-balken rect.cfill'.$balken_schluessel] = 'fill:'.$this->VektorGrafikCSSSaeubern($balken_name[1]).';';
		$this->svg_stilvorlagen['diagramm-werte-zeigen rect.cfill'.$balken_schluessel] = 'fill:'.$this->VektorGrafikCSSSaeubern($balken_name[1]).';';
		}
	return true;
	}

	protected function VektorGrafikCSSSaeubern($wert){
	return preg_replace('/[^a-z0-9 #,"\-]+/i','',$wert);
	}

	protected function ErmittleVergleichsJahre($jahre,$station){
	global $einstellungen;
	$this->KonsolenAusgabe(__FUNCTION__.'() '.$jahre,3);
	$verfuegbar = array(1700,(int)date('Y'));
	$zeitraum = $this->JahresZeitraumErstellen($jahre);
		if ( !$zeitraum )
		return array();
		if ( extension_loaded('simplexml') ){
			if ( file_exists($einstellungen['zwischenspeicher']['speicher_pfad'].'/'.$this->cli_parameter['station'].'.manifest') ){
			$manifest = simplexml_load_file($einstellungen['zwischenspeicher']['speicher_pfad'].'/'.$this->cli_parameter['station'].'.manifest');
				if ( isset($manifest->zeitreihe) ){
				$manifest = explode(' ',$manifest->zeitreihe);
				$verfuegbar = array((int)substr($manifest[0],0,4),(int)substr($manifest[1],0,4));
				}
			}
		}
		foreach ( $zeitraum as $schluessel=>$wert ){
			if ( $wert < min($verfuegbar) || $wert > max($verfuegbar) )
			unset($zeitraum[$schluessel]);
		}
		if ( preg_match('/^(\d+)\-(\d+)$/m',$this->cli_parameter['vergleich'],$vergleich) ){
			if ( (int)$vergleich[1] < min($verfuegbar) )
			$vergleich[1] = min($verfuegbar);
			if ( (int)$vergleich[2] > max($verfuegbar) )
			$vergleich[2] = max($verfuegbar);
		unset($vergleich[0]);
		$this->cli_parameter['vergleich'] = implode('-',$vergleich);
		}
	return array_unique($zeitraum);
	}

	protected function SchluesselWertNachString($daten){
	$ausgabe = '';
		foreach ( $daten as $schluessel=>$wert )
		$ausgabe .= $schluessel."='".$wert."' ";
	return rtrim($ausgabe);
	}

	protected function MakrosErsetzen(&$eingabe,$wert){
	global $einstellungen;
	$eingabe = str_replace('%w',$einstellungen['grafik']['breite'],$eingabe);
	$eingabe = str_replace('%h',$einstellungen['grafik']['hoehe'],$eingabe);
	$eingabe = str_replace('!!!!',$einstellungen['grafik']['diagramm_abstand']*4,$eingabe); // nicht tauschen mit !!!
	$eingabe = str_replace('!!!',$einstellungen['grafik']['diagramm_abstand']*3,$eingabe); // nicht tauschen mit !!
	$eingabe = str_replace('!!',$einstellungen['grafik']['diagramm_abstand']*2,$eingabe); // nicht tauschen mit !
	$eingabe = str_replace('!',$einstellungen['grafik']['diagramm_abstand'],$eingabe);
	}

	protected function ZwischenspeicherLesen(&$datei){
		if ( !file_exists($datei) )
		return false;
	$daten = file_get_contents($datei);
	$pruefsumme = strpos($daten,'checksum=');
		if ( $pruefsumme !== false )
		$pruefsumme = substr($daten,$pruefsumme+9,8);
	$daten = substr($daten,strpos($daten,"\r\n\r\n<=>")+7);
	$daten = str_replace(array("\r","\n"),array('',''),$daten);
		if ( is_string($pruefsumme) && $pruefsumme !== sprintf('%x',crc32($daten)) )
		return false;
	return unserialize($daten);
	}

	protected function ZwischenspeicherSchreiben(&$datei,&$daten,$kopf){
	$serialisiert = serialize($daten);
	$cache = chunk_split("; ".$kopf." checksum=".sprintf("%x",crc32($serialisiert))."\r\n\r\n<=>".$serialisiert);
	return $this->file_put_contents_wrapper($datei,$cache);
	}

	protected function FiltereDatenNachDekaden(&$datensatz,&$daten_fertig,$jahre){
	global $einstellungen;
	$daten_temp = array();
	$daten_fertig = array();
	$tage_bearbeitet = 0;
		if ( !is_array($jahre) && is_numeric($jahre) )
		$jahre = array((int)$jahre);
	$this->KonsolenAusgabe(__FUNCTION__.'() Die Jahre '.implode(',',$jahre).' werden ausgewählt',2);
	$this->KonsolenAusgabe(__FUNCTION__.'() '.sizeof($datensatz).' Datensätze werden gefiltert',2);
		foreach ( $datensatz as $daten ){
			if ( !in_array($daten['jahr'],$jahre,true) )
			continue;
		$dekade = $this->ErmittleDekade($daten['tag']);
		$schluessel = $daten['monat'].'/'.$dekade;
			if ( !isset($daten_temp[$schluessel]) )
			$daten_temp[$schluessel] = $this->grundgeruest_werte;
			foreach ( $this->datenreihen as $wert ){
				if ( $daten_temp[$schluessel][$wert] === 0 )
				$daten_temp[$schluessel][$wert] = array();
				//if ( $daten[$wert] !== '---' )
				$daten_temp[$schluessel][$wert][] = $daten[$wert];
			}
		$tage_bearbeitet++;
		}

	$this->KonsolenAusgabe(__FUNCTION__.'() '.$tage_bearbeitet.' Tage wurden bearbeitet',2);
		foreach ( $daten_temp as $schluessel=>$daten ){
			foreach ( $this->datenreihen as $wert ){
				if ( sizeof($daten_temp[$schluessel][$wert]) === 0 )
				continue;
				if ( substr($wert,0,1) === '%' ){
					if ( $schluessel === '2/3' ){
						if ( sizeof($jahre) === 1 )
						$tage_in_dekade = date('t',mktime(0,0,0,2,1,$jahre[0]))-20;
						else
						$tage_in_dekade = 8; // Schaltjahre ausgenommen! Ja, schlagt mich ;)
					}
					elseif ( in_array($schluessel,array('1/3','3/3','5/3','7/3','8/3','10/3','12/3')) )
					$tage_in_dekade = 11;
					else
					$tage_in_dekade = 10;
					if ( $wert === '%sonnenschein' )
					$daten_fertig[$schluessel][$wert] = round( array_sum($daten_temp[$schluessel][$wert]) / sizeof($daten_temp[$schluessel][$wert]) * 100 , 0);
					else
					$daten_fertig[$schluessel][$wert] = round( array_sum($daten_temp[$schluessel][$wert]) / sizeof($daten_temp[$schluessel][$wert]) * $tage_in_dekade, 0);
				}
				else{
				$this->UngueltigeDatensaetzeEntfernen($daten_temp[$schluessel][$wert],sprintf('%s::%s',$schluessel,$wert));
				$daten_fertig[$schluessel][$wert] = round( array_sum($daten_temp[$schluessel][$wert]) / sizeof($daten_temp[$schluessel][$wert]), 1);
				}
			}
		}

	$this->KonsolenAusgabe(__FUNCTION__.'() Filterung abgeschlossen',2);
	}

	protected function FiltereDatenNachJahre(&$datensatz,&$daten_fertig,$jahre){
	$daten_fertig = array();
	$tage_bearbeitet = 0;
		if ( !is_array($jahre) && is_numeric($jahre) )
		$jahre = array((int)$jahre);
	$this->KonsolenAusgabe(__FUNCTION__.'() Die Jahre '.implode(',',$jahre).' werden ausgewählt',2);
	$this->KonsolenAusgabe(__FUNCTION__.'() '.sizeof($datensatz).' Datensätze werden gefiltert',2);
		foreach ( $datensatz as $daten ){
			if ( !in_array($daten['jahr'],$jahre,true) )
			continue;
		$daten_fertig[] = $daten;
		$tage_bearbeitet++;
		}
	$this->KonsolenAusgabe(__FUNCTION__.'() '.$tage_bearbeitet.' Tage wurden bearbeitet',2);
	$this->KonsolenAusgabe(__FUNCTION__.'() Filterung abgeschlossen',2);
	}

	protected function HoleRohDaten($station,$einzeljahr=''){
	global $einstellungen;
	$datensatz = array();
	$korrekturen = array();
	$typ = $einstellungen['daten'][$this->cli_parameter['station']]['typus'];
	$sonnenschein_zwischenspeicher_pfad = $einstellungen['zwischenspeicher']['speicher_pfad'].'/'.$station.'.00000000.sunshine';
		if ( extension_loaded('simplexml') && file_exists($einstellungen['zwischenspeicher']['speicher_pfad'].'/'.$this->cli_parameter['station'].'.manifest') )
		$manifest = simplexml_load_file($einstellungen['zwischenspeicher']['speicher_pfad'].'/'.$this->cli_parameter['station'].'.manifest');
	$this->KonsolenAusgabe(__FUNCTION__.'() Für Station '.$station.' mit dem Typ '.$typ,2);
	$letzter_satz = '00000000';
		if ( $this->nutze_optimierungen ){
		$sonnenschein_daten = $this->ZwischenspeicherLesen($sonnenschein_zwischenspeicher_pfad);
			if ( is_array($sonnenschein_daten) && sizeof($sonnenschein_daten) >= 365 ){
			$this->KonsolenAusgabe('Vorberechnete astronomische Sonnenscheindauer wurde aus dem Zwischenspeicher geholt',2);
			$this->KonsolenAusgabe('Sonnenscheindauer wurde berechnet',2);
			}
			else
			$sonnenschein_daten = $this->Berechne_Astronomische_Sonnenscheindauer($einstellungen['daten'][$station]['position']);
		}
		else
		$sonnenschein_daten = $this->Berechne_Astronomische_Sonnenscheindauer($einstellungen['daten'][$station]['position']);
	$daten_korrekturen = WADE_ROOT_PATH.'/korrekturen-'.$this->cli_parameter['station'].'.txt';
		if ( is_file($daten_korrekturen) ){
		$this->KonsolenAusgabe('Korrekturdatei für Station '.$this->cli_parameter['station'].' gefunden',2);
		$daten_korrekturen = file($daten_korrekturen,FILE_IGNORE_NEW_LINES|FILE_SKIP_EMPTY_LINES);
			foreach ( $daten_korrekturen as $datensatz ){
				if ( !is_numeric(substr($datensatz,0,1)) )
				continue;
			$datensatz = explode(' ',$datensatz);
				// Jahr Monat Tag Datensatz-Name Wert-Erwartet Wert-Geändert
				if ( in_array($datensatz[3],$this->datenreihen,true) )
				$korrekturen[(int)$datensatz[0]][(int)$datensatz[1]][(int)$datensatz[2]][$datensatz[3]] = array((double)$datensatz[4],(double)$datensatz[5]);
			}
		$this->KonsolenAusgabe(sizeof($korrekturen).' von '.sizeof($daten_korrekturen).' Korrekturen wurden erfolgreich eingelesen',2);
		unset($daten_korrekturen,$datensatz);
		}

		foreach ( $einstellungen['daten'][$station]['roh_daten'] as $id=>$datei ){
		$this->KonsolenAusgabe('Bearbeite Roh-Datei #'.$id.' - '.basename($datei),2);
		$uuid = sprintf('%u',crc32($datei));
		$lokaler_pfad = $einstellungen['zwischenspeicher']['speicher_pfad'].'/'.$this->cli_parameter['station'].'.'.$uuid;
			if ( !file_exists($lokaler_pfad) ){
			$this->KonsolenAusgabe(__FUNCTION__.'() Roh-Datei konnte nicht im Zwischenspeicher gefunden werden',2);
			continue;
			}
		$gefundene_jahre = 'gefundene_jahre_'.$uuid;
			if ( $this->nutze_optimierungen && is_numeric($einzeljahr) && isset($manifest) && isset($manifest->$gefundene_jahre) ){
			$gefundene_jahre = explode(',',$manifest->$gefundene_jahre);
				if ( !in_array($einzeljahr,$gefundene_jahre) ){
				$this->KonsolenAusgabe(__FUNCTION__.'() Das geforderte Einzeljahr '.$einzeljahr.' nicht gefunden',2);
				$this->KonsolenAusgabe(__FUNCTION__.'() Überspringe daher das weitere Bearbeiten dieser Roh-Datei',2);
				continue;
				}
			}
		$pruefsumme = 'pruefsumme_'.$uuid;
			if ( isset($manifest) && isset($manifest->$pruefsumme) ){
				if ( sha1_file($lokaler_pfad) !== strval($manifest->$pruefsumme) )
				$this->KonsolenAusgabe('Die Roh-Datei wurde seit dem letzten Import verändert',2);
			}

		$magische_bytes = file_get_contents($lokaler_pfad,false,null,0,3);
		$kompression_helfer = ( bin2hex($magische_bytes) === '1f8b08' ) ? 'compress.zlib://' : 'file://';
		$roh = ( file_exists($lokaler_pfad) ) ? file($kompression_helfer.$lokaler_pfad,FILE_IGNORE_NEW_LINES|FILE_SKIP_EMPTY_LINES) : array();
		$this->KonsolenAusgabe(__FUNCTION__.'() Lese Datei aus dem Zwischenspeicher '.basename($lokaler_pfad),2);
			if ( !is_array($roh) || sizeof($roh) < 10 )
			continue;
		$this->KonsolenAusgabe(__FUNCTION__.'() Gefundene Zeilen '.sizeof($roh),2);

			switch ( $typ ){
			case 'dwd_kl2000': $extraktionsfunktion = 'ExtrahiereDatenDWDFormatKL2000'; break;
			case 'dwd_hist': $extraktionsfunktion = 'ExtrahiereDatenDWDFormatHistorisch'; break;
			default:
			$this->KonsolenAusgabe(__FUNCTION__.'() Die geforderte Funktion "'.$extraktionsfunktion.'" für das Datenformat konnte nicht gefunden werden',-1);
			$extraktionsfunktion = '';
			break;
			}

		// NOTE: Güte-Angabe der Daten berücksichtigen?
		// NOTE: Art des Niederschlags (NIEDERSCHLAGSHOEHE_IND | http://www.dwd.de/DE/leistungen/klimadatendeutschland/beschreibung_tagesmonatswerte.html?nn=16102&lsbId=343278)

			foreach ( $roh as $zeile ){
				if ( strlen($extraktionsfunktion) === 0 )
				break;
			$satz = call_user_func(array($this,$extraktionsfunktion),$zeile);
				if ( !is_array($satz) )
				continue;
			$zeitstempel_kurz = sprintf('%02d%02d',$satz['monat'],$satz['tag']);
			$this->RohDatenKorrigieren($satz,$korrekturen);
			$this->RohDatenValidieren($satz);

				if ( is_numeric($satz['temperatur_max']) && $satz['temperatur_max'] >= 30 ){
				$satz['%tropentag'] = 1;
				$satz['%sommertag'] = 1;
				}
				elseif ( is_numeric($satz['temperatur_max']) && $satz['temperatur_max'] >= 25 )
				$satz['%sommertag'] = 1;

				if ( is_numeric($satz['temperatur_max']) && $satz['temperatur_max'] <= 0 ){
				$satz['%eistag'] = 1;
				$satz['%frosttag'] = 1;
				}
				elseif ( is_numeric($satz['temperatur_min']) && $satz['temperatur_min'] <= 0 )
				$satz['%frosttag'] = 1;

				if ( is_numeric($satz['temperatur_min']) && $satz['temperatur_min'] >= 20 ){
				$satz['%tropennacht'] = 1;
				$satz['%mildnacht'] = 1;
				}
				elseif ( is_numeric($satz['temperatur_min']) && $satz['temperatur_min'] >= 17.5 )
				$satz['%mildnacht'] = 1;

				if ( is_numeric($satz['niederschlag']) && $satz['niederschlag'] >= $this->niederschlagsgrenze_fuer_regentag_in_mm )
				$satz['%regentag'] = 1;

				if ( is_numeric($satz['schneehoehe']) && $satz['schneehoehe'] > 0 )
				$satz['%schneetag'] = 1;

				if ( isset($sonnenschein_daten[$zeitstempel_kurz]) && $satz['sonne'] !== '---' )
				$satz['%sonnenschein'] = round($satz['sonne']/$sonnenschein_daten[$zeitstempel_kurz],2);
				else
				$satz['%sonnenschein'] = '---';

			$schluessel = $this->DatumZeichenketteWandeln($satz);
			$datensatz[$schluessel] = $satz;
			$letzter_satz = $schluessel;
			}

		} // foreach rohdatei

	unset($roh,$satz,$zeitstempel_kurz,$extraktionsfunktion,$schluessel);
	ksort($datensatz); // Schön alle Tage aufsteigend hintereinander...

		if ( $letzter_satz > 0 && sizeof($datensatz) > 0 ){
		$verschnitt = intval(substr($letzter_satz,-2))%10;
			if ( $verschnitt !== 0 && !in_array(substr($letzter_satz,4),array('0228','0229')) && (int)substr($letzter_satz,-2) !== 31 ){
			$this->KonsolenAusgabe(__FUNCTION__.'() Verwerfe '.$verschnitt.' Tage, da die letzte Dekade unvollständig ist',2);
				for ( $i = 1 ; $i <= $verschnitt ; $i++ )
				array_pop($datensatz);
			$letzter_satz = array_pop($datensatz);
			$datensatz[] = $letzter_satz;
			$this->KonsolenAusgabe(__FUNCTION__.'() Der letzte Datensatz trägt das Kalenderdatum "'.$this->DatumZeichenketteWandeln($letzter_satz).'"',2);
			}
		}

	$this->KonsolenAusgabe(__FUNCTION__.'() '.sizeof($datensatz).' Datensätze eingelesen und verarbeitet',2);
		if ( $this->nutze_optimierungen && !file_exists($sonnenschein_zwischenspeicher_pfad) ){
		$this->ZwischenspeicherSchreiben($sonnenschein_zwischenspeicher_pfad,$sonnenschein_daten,'sunshine data cache - ');
		$this->KonsolenAusgabe('Berechnete astronomische Sonnenscheindauer wurde zum schnelleren Bereitstellen in den Zwischenspeicher gepackt',2);
		}
	return $datensatz;
	}

	/* NOTE: Berücksichtigt nicht die Höhe der Station. Aus der php.ini folgt
	; The best Overall figure for zenith is 90+(50/60) degrees for true sunrise/sunset
	; Civil twilight 96 degrees - Conventionally used to signify twilight
	; Nautical twilight 102 degrees - the point at which the horizon stops being visible at sea.
	; Astronical twilight at 108 degrees - the point when Sun stops being a source of any illumination. */
	protected function Berechne_Astronomische_Sonnenscheindauer($geokoordinaten){
		if ( !preg_match('/^[\d\.]+ [\d\.]+$/uD',$geokoordinaten) )
		return false;
	$daten = array();
	$zenit = 90+(50/60);
	$geokoordinaten = explode(' ',$geokoordinaten);
		for ( $a = 1 ; $a <= 12 ; $a++ ){
			for ( $b = 1 ; $b <= 31 ; $b++ ){
				if ( checkdate($a,$b,2000) ){ // Schaltjahr
				$schluessel = sprintf('%02d',$a).sprintf('%02d',$b);
				$sa = date_sunrise(gmmktime(0,0,0,$a,$b,2000),SUNFUNCS_RET_TIMESTAMP,$geokoordinaten[0],$geokoordinaten[1],$zenit,0);
				$su = date_sunset(gmmktime(0,0,0,$a,$b,2000),SUNFUNCS_RET_TIMESTAMP,$geokoordinaten[0],$geokoordinaten[1],$zenit,0);
					if ( is_integer($sa) && is_integer($su) )
					$daten[$schluessel] = round(($su-$sa)/3600,1);
					else
					$daten[$schluessel] = 24;
				}
			}
		}
	$this->KonsolenAusgabe('Astronomische Sonnenscheindauer wurde berechnet',2);
	return $daten;
	}

	protected function RohDatenValidieren(&$satz){
		if ( $satz['temperatur_max'] < -50 || $satz['temperatur_max'] > 75 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['temperatur_max'].'" bei "temperatur_max" mit dem Datum '.$this->DatumZeichenketteWandeln($satz),3);
		$satz['temperatur_max'] = '---';
		}
		if ( $satz['temperatur_min'] < -90 || $satz['temperatur_min'] > 75 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['temperatur_min'].'" bei "temperatur_min" mit dem Datum '.$this->DatumZeichenketteWandeln($satz),3);
		$satz['temperatur_min'] = '---';
		}
		if ( $satz['temperatur_mit'] < -50 || $satz['temperatur_mit'] > 75 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['temperatur_mit'].'" bei "temperatur_mit" mit dem Datum '.$this->DatumZeichenketteWandeln($satz),3);
		$satz['temperatur_mit'] = '---';
		}
		if ( $satz['luftdruck_mit'] < 500 || $satz['luftdruck_mit'] > 1100 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['luftdruck_mit'].'" bei "luftdruck_mit" mit dem Datum '.$this->DatumZeichenketteWandeln($satz),3);
		$satz['luftdruck_mit'] = '---';
		}
		if ( $satz['feuchte_mit'] < 0 || $satz['feuchte_mit'] > 100 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['feuchte_mit'].'" bei "feuchte_mit" mit dem Datum '.$this->DatumZeichenketteWandeln($satz),3);
		$satz['feuchte_max'] = '---';
		}
		if ( $satz['wind_mit'] < 0 || $satz['wind_mit'] > 255 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['wind_mit'].'" bei "wind_mit" mit dem Datum '.$this->DatumZeichenketteWandeln($satz),3);
		$satz['wind_mit'] = '---';
		}
		if ( $satz['sonne'] < 0 || $satz['sonne'] > 24 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['sonne'].'" bei "sonne" mit dem Datum '.$this->DatumZeichenketteWandeln($satz),3);
		$satz['sonne'] = '---';
		}
		if ( $satz['niederschlag'] < 0 || $satz['niederschlag'] > 1000 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['niederschlag'].'" bei "niederschlag" mit dem Datum '.$this->DatumZeichenketteWandeln($satz),3);
		$satz['niederschlag'] = '---';
		}
		if ( $satz['schneehoehe'] < 0 || $satz['schneehoehe'] > 1000 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['schneehoehe'].'" bei "schneehoehe" mit dem Datum '.$this->DatumZeichenketteWandeln($satz),3);
		$satz['schneehoehe'] = '---';
		}
/*		if ( $satz['wolken_6h'] < 0 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['wolken_6h'].'" bei "wolken_6h" mit dem Datum '.$this->DatumZeichenketteWandeln($satz),3);
		$satz['wolken_6h'] = '---';
		}
		if ( $satz['wolken_12h'] < 0 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['wolken_12h'].'" bei "wolken_12h" mit dem Datum '.$this->DatumZeichenketteWandeln($satz),3);
		$satz['wolken_12h'] = '---';
		}
		if ( $satz['wolken_18h'] < 0 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['wolken_18h'].'" bei "wolken_18h" mit dem Datum '.$this->DatumZeichenketteWandeln($satz),3);
		$satz['wolken_18h'] = '---';
		}*/
		if ( $satz['wolken_mit'] < 0 || $satz['wolken_mit'] > 10 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['wolken_mit'].'" bei "wolken_mit" mit dem Datum '.$this->DatumZeichenketteWandeln($satz),3);
		$satz['wolken_mit'] = '---';
		}
	}

	protected function RohDatenKorrigieren(&$satz,&$korrekturen){
		if ( isset($korrekturen[$satz['jahr']]) ){
			if ( isset($korrekturen[$satz['jahr']][$satz['monat']]) ){
				if ( isset($korrekturen[$satz['jahr']][$satz['monat']][$satz['tag']]) ){
					foreach ( $korrekturen[$satz['jahr']][$satz['monat']][$satz['tag']] as $datenreihe=>$neue_daten ){
						if ( isset($satz[$datenreihe]) && $satz[$datenreihe] === $neue_daten[0] ){
						$this->KonsolenAusgabe(__FUNCTION__.'() Korrigiere '.$datenreihe.' von "'.$neue_daten[0].'" zu "'.$neue_daten[1].'" am "'.$this->DatumZeichenketteWandeln($satz).'"',2);
						$satz[$datenreihe] = $neue_daten[1];
						}
					}
				}
			}
		}
	}

	public function UngueltigeDatensaetzeEntfernen(&$werte,$name=''){
	$ratio = 1;
	$entfernt = 0;
		if ( is_array($werte) ){
			foreach ( $werte as $schluessel=>$wert ){
				if ( $wert === '---' ){
				unset($werte[$schluessel]);
				$name .= ' +'.$schluessel;
				$entfernt++;
				}
			}
		}
		if ( $entfernt > 0 ){
		$menge = sizeof($werte);
			if ( $menge > 0 ){
			$ratio = round(($menge-$entfernt)/$menge,1);
			$this->KonsolenAusgabe(__FUNCTION__.'() '.$entfernt.' Stück aus "'.trim($name).'" entfernt, '.$menge.' (='.$ratio.') sind gültig.',3);
			}
		}
	return $ratio;
	}

	protected function ExtrahiereDatenDWDFormatKL2000($zeile){
		if ( strlen($zeile) < 128 )
		return false;
		if ( substr($zeile,0,2) === 'KK' ) // TODO: kompatibles Format zu KL/KX?
		return false;
	return array(
	'jahr'=>(int)substr($zeile,7,4),
	'monat'=>(int)substr($zeile,11,2),
	'tag'=>(int)substr($zeile,13,2),
	'luftdruck_mit'=>(double)substr($zeile,37,5)/10,
	'temperatur_max'=>(double)substr($zeile,43,4)/10,
	'temperatur_min'=>(double)substr($zeile,48,4)/10,
	'temperatur_mit'=>(double)substr($zeile,78,4)/10,
	'feuchte_mit'=>(int)substr($zeile,130,2),
	'wind_mit'=>(int)substr($zeile,161,2),
	'sonne'=>(double)substr($zeile,195,3)/10,
/*				'wolken_6h'=>(int)substr($zeile,164,2),
	'wolken_12h'=>(int)substr($zeile,173,2),
	'wolken_18h'=>(int)substr($zeile,182,2),*/
	'wolken_mit'=>(double)substr($zeile,191,3)/10,
	'niederschlag'=>(double)substr($zeile,246,3)/10,
	'schneehoehe'=>(double)substr($zeile,252,2),
	'%tropentag'=>0,
	'%sommertag'=>0,
	'%frosttag'=>0,
	'%eistag'=>0,
	'%tropennacht'=>0,
	'%mildnacht'=>0,
	'%regentag'=>0,
	'%schneetag'=>0,
	'%sonnenschein'=>0
	);
	}

	protected function ExtrahiereDatenDWDFormatHistorisch($zeile){
		if ( strlen($zeile) < 130 || strlen($zeile) > 312 )
		return false;
	return array(
	'jahr'=>(int)substr($zeile,10,4),
	'monat'=>(int)substr($zeile,14,2),
	'tag'=>(int)substr($zeile,16,2),
	'luftdruck_mit'=>round((double)substr($zeile,56,7),1),
	'temperatur_max'=>(double)substr($zeile,88,6),
	'temperatur_min'=>(double)substr($zeile,80,6),
	'temperatur_mit'=>(double)substr($zeile,48,7),
	'feuchte_mit'=>(int)substr($zeile,34,4),
	'wind_mit'=>(int)substr($zeile,65,5),
	'sonne'=>round((double)substr($zeile,115,8),1),
	'wolken_mit'=>(double)substr($zeile,25,5),
	'niederschlag'=>(double)substr($zeile,108,5),
	'schneehoehe'=>-1, // TODO: einbauen, falls verfügbar
	'%tropentag'=>0,
	'%sommertag'=>0,
	'%frosttag'=>0,
	'%eistag'=>0,
	'%tropennacht'=>0,
	'%mildnacht'=>0,
	'%regentag'=>0,
	'%schneetag'=>0,
	'%sonnenschein'=>0
	);
	}

	public function Zeitmessung($name = ''){
	static $zeitpunkte = array();
		if ( sizeof($zeitpunkte) === 0 ){
		$zeitpunkte[] = array('start',microtime(true));
		return 0;
		}
		else{
		$zeitpunkte[] = array($name,microtime(true));
		$letzte = sizeof($zeitpunkte)-1;
		$vorletzte = sizeof($zeitpunkte)-2;
		return $name.':'.number_format(($zeitpunkte[$letzte][1]-$zeitpunkte[$vorletzte][1])*1000,3,'.',' ').'ms';
		}
	}

	public function KonsolenAusgabe($text,$gewicht){
		if ( !$this->cli_parameter['psst_still_sein'] && intval($gewicht) <= $this->cli_parameter['debug_ausgabe'] ){
		echo '['.sprintf('%6.3f',round(microtime(true)-$this->startzeit,3)).'s ::';
		echo ' '.sprintf('%4.1f',round(memory_get_usage(true)/1048576,1)).' MiB ] ';
		echo $text;
		echo chr(10);
		}
		if ( (int)$gewicht === -1 )
		die();
	return true;
	}

	public function file_put_contents_wrapper(){
		if ( defined('HEY_DONT_YOU_CHANGE_DATA') )
		return true;
	$args = func_get_args();
	return call_user_func_array('file_put_contents',$args);
	}

	public function JahresZeitraumErstellen($jahre){
	$jahre = explode(',',preg_replace('/[^0-9,\-]+/','',str_replace('%aktuelles-jahr%',date('Y'),$jahre)));
	$zeitraum = array();
		foreach ( $jahre as $wert ){
			if ( strpos($wert,'-') ){
			$wert = explode('-',$wert);
				if ( sizeof($wert) !== 2 || !is_numeric($wert[0]) || !is_numeric($wert[1]) )
				continue;
				for ( $a = (int)$wert[0] ; $a <= (int)$wert[1] ; $a++ )
				$zeitraum[] = $a;
			}
			else
			$zeitraum[] = (int)$wert;
		}
	return ( sizeof($zeitraum) > 0 ) ? $zeitraum : false;
	}

	public function GPSNachLesbar($daten){
	$ausgabe = '';
	$daten = explode(' ',$daten);
	$ausgabe .= ( doubleval($daten[0]) > 0 ) ? (double)$daten[0].'N ' : (double)$daten[0].'S ';
	$ausgabe .= ( doubleval($daten[1]) > 0 ) ? (double)$daten[1].'E ' : (double)$daten[1].'W ';
	return rtrim($ausgabe);
	}

	public function ZeitstempelNachLesbar($datum){
	$tag = substr($datum,6);
	$monat = substr($datum,4,2);
	$jahr = substr($datum,0,4);
	return $tag.'. '.strftime('%B',strtotime('1999'.$monat.'01')).' '.$jahr;
	}

	public function HuebscheZahlen($wert,$nachkommastellen=1,$pluseinfuegen=true){
	$wert = number_format($wert,$nachkommastellen,',',' ');
		if ( $pluseinfuegen && substr($wert,0,1) !== '-' )
		$wert = '+'.$wert;
	return $wert;
	}

	public function ErmittleDekade($tag){
	$tag = intval($tag);
		if ( $tag < 11 )
		return 1;
		elseif ( $tag < 21 )
		return 2;
		else
		return 3;
	}

	public function DekadeNachLokalisiertesDatum($daten,$monat='%b',$trenner="\n"){
	$daten = explode('/',$daten);
	$datum = mktime(0,0,0,$daten[0],1,2000);
	return strftime($monat,$datum).$trenner.$daten[1];
	}

	public function ErmittleDekadenAuswahl($modul){
	global $einstellungen;
	$dekaden_auswahl = array();
	$daten_temp = explode(',',$einstellungen[$modul]['dekaden_auswahl']);
		if ( $daten_temp[0] === '*' ){
			for ( $m = 1 ; $m <= 12 ; $m++ ){
				for ( $d = 1 ; $d <= 3 ; $d++ )
				$dekaden_auswahl[] = $m.'/'.$d;
			}
		}
		else{
			foreach ( $daten_temp as $wert ){
			preg_match('|^([a-z0-9]{1,3})[^a-z0-9]+([123\*]{1})$|iD',$wert,$wert);
				if ( is_array($wert) && sizeof($wert) === 3 ){
				$monat = $this->StrMonatNachZahl($wert[1]);
					if ( $monat === 0 )
					continue;
					if ( $wert[2] === '*' ){
					$dekaden_auswahl[] = $monat.'/1';
					$dekaden_auswahl[] = $monat.'/2';
					$dekaden_auswahl[] = $monat.'/3';
					}
					else
					$dekaden_auswahl[] = $monat.'/'.(int)$wert[2];
				}
			}
		}
	return $dekaden_auswahl;
	}

	public function StrMonatNachZahl($monat){
	$monat = strtolower($monat);
	$zk = array('jan','feb','mar','apr','mai','jun','jul','aug','sep','okt','nov','dez');
	$za = array(1,2,3,4,5,6,7,8,9,10,11,12);
	return intval(str_replace($zk,$za,$monat));
	}

	public function StrZahlNachMonat($monat){
			switch ( (int)$monat ){
			case 1: $name = 'Jan'; break;
			case 2: $name = 'Feb'; break;
			case 3: $name = 'Mar'; break;
			case 4: $name = 'Apr'; break;
			case 5: $name = 'May'; break;
			case 6: $name = 'Jun'; break;
			case 7: $name = 'Jul'; break;
			case 8: $name = 'Aug'; break;
			case 9: $name = 'Sep'; break;
			case 10: $name = 'Oct'; break;
			case 11: $name = 'Nov'; break;
			case 12: $name = 'Dec'; break;
			}
	return $name;
	}

	public function DatumZeichenketteWandeln($daten,$weitere_berechnungen=false){
		if ( is_array($daten) && sizeof($daten) >= 3 )
		return intval(sprintf('%04d%02d%02d',$daten['jahr'],$daten['monat'],$daten['tag']));
		else{
		$ausgabe = array('jahr'=>intval(substr($daten,0,4)),'monat'=>intval(substr($daten,4,2)),'tag'=>intval(substr($daten,6)));
			if ( $weitere_berechnungen ){
			$ausgabe['monat_name'] = $this->StrZahlNachMonat($ausgabe['monat']);
			$ausgabe['dekade'] = $this->ErmittleDekade($ausgabe['tag']);
			}
		return $ausgabe;
		}
	}

	public function HoleVergleichsMittelDerJahre($station,$jahre){
	global $einstellungen;
	$this->KonsolenAusgabe('Berechne Vergleichsmittel der Station '.$station.' für '.$jahre,1);
	$daten = array();
	$jahre = $this->ErmittleVergleichsJahre($jahre,$station);
	$uuid = sprintf('%u',crc32(implode('',$jahre)));
	$lokaler_pfad = $einstellungen['zwischenspeicher']['speicher_pfad'].'/'.$station.'.'.$uuid.'.climate';
		if ( $this->nutze_optimierungen ){
		$daten = $this->ZwischenspeicherLesen($lokaler_pfad);
			if ( is_array($daten) && sizeof($daten) === 36 ){
			$this->KonsolenAusgabe('Vorberechnete Daten wurden aus dem Zwischenspeicher geholt',2);
			$this->KonsolenAusgabe('Vergleichsmittel wurde berechnet',2);
			return $daten;
			}
		}
	$datensatz = $this->HoleRohDaten($station);
	$this->FiltereDatenNachDekaden($datensatz,$daten,$jahre);
		if ( $this->nutze_optimierungen ){
		$this->ZwischenspeicherSchreiben($lokaler_pfad,$daten,'clino data cache - years='.implode(',',$jahre));
		$this->KonsolenAusgabe('Berechnete Daten wurden zum schnelleren Bereitstellen in den Zwischenspeicher gepackt',2);
		}
	$this->KonsolenAusgabe('Vergleichsmittel wurde berechnet',2);
	return $daten;
	}

	public function HoleStationsDatenDesJahres($station,$jahr){
	$this->KonsolenAusgabe('Berechne Jahresdaten der Station '.$station.' für '.$jahr,1);
	$daten = array();
	$datensatz = $this->HoleRohDaten($station,$jahr);
	$this->FiltereDatenNachDekaden($datensatz,$daten,$jahr);
	$this->KonsolenAusgabe('Jahresdaten wurden berechnet',2);
	return $daten;
	}

	public function HoleRoheDatenDerJahre($station,$jahr){
	$this->KonsolenAusgabe('Berechne alle Daten der Station '.$station.' für '.$jahr,1);
	$daten = array();
	$jahr = $this->ErmittleVergleichsJahre($jahr,$station);
	$datensatz = $this->HoleRohDaten($station);
	$this->FiltereDatenNachJahre($datensatz,$daten,$jahr);
	$this->KonsolenAusgabe('Daten wurden berechnet',2);
	return $daten;
	}

	public function BerechneYAchse_Abweichung($wert){
	global $einstellungen;
	$diagramm_hoehe = $einstellungen['grafik']['hoehe']-(3*$einstellungen['grafik']['diagramm_abstand']);
	$diagramm_mitte = ($diagramm_hoehe/2);
	$balken_hoehe = (abs($wert)/$einstellungen['grafik']['diagramm_y_achse_maximum'])*$diagramm_mitte;
	$koordinaten = array($diagramm_mitte,$diagramm_mitte,0); // absolut, start, höhe
		if ( $wert < 0 ){
		$koordinaten[0] = $diagramm_mitte+$balken_hoehe;
		$koordinaten[1] = $diagramm_mitte;
		$koordinaten[2] = $balken_hoehe;
		}
		elseif ( $wert > 0 ){
		$koordinaten[0] = $diagramm_mitte-$balken_hoehe;
		$koordinaten[1] = $diagramm_mitte-$balken_hoehe;
		$koordinaten[2] = $balken_hoehe;
		}
	$koordinaten[0] += $einstellungen['grafik']['diagramm_abstand']*2;
	$koordinaten[1] += $einstellungen['grafik']['diagramm_abstand']*2;
	$this->KonsolenAusgabe(__FUNCTION__.'() wert='.$wert.' coords='.implode(',',$koordinaten),3);
	return $koordinaten;
	}

	public function BerechneYAchse_Absolut($wert,&$begrenzung){
	global $einstellungen;
	$diagramm_hoehe = $einstellungen['grafik']['hoehe']-(3*$einstellungen['grafik']['diagramm_abstand']);
	$werte_groesse = abs($begrenzung['max'])+abs($begrenzung['min']);
		if ( $wert >= 0 )
		$wert_abs = $wert+abs($begrenzung['min']);
		else
		$wert_abs = abs($begrenzung['min'])-abs($wert);
	$wert_hoehe = ($wert_abs/$werte_groesse)*$diagramm_hoehe;
	$koordinaten[0] = $diagramm_hoehe-$wert_hoehe+(2*$einstellungen['grafik']['diagramm_abstand']);
	$this->KonsolenAusgabe(__FUNCTION__.'() wert='.$wert.' coords='.implode(',',$koordinaten),3);
	return $koordinaten;
	}

	public function VektorGrafikPuffer($gruppe,$element,$attribute,$daten=''){
	global $einstellungen;
	static $warteschlange = array();
		if ( !$this->svg_stilvorlagen )
		$this->VektorGrafikStilvorlagenErzeugen();
		if ( $element === '%' )
		return $warteschlange;
	$attribute_roh = $attribute.',';
		if ( !isset($warteschlange[$gruppe]) )
		$warteschlange[$gruppe] = array();
	$attribute = $this->AttributeZeichenketteVerarbeiten($attribute_roh);
		foreach ( $attribute as $schluessel=>$wert ){
			if ( in_array($schluessel,array('x','y','x1','x2','y1','y2','width','height'),true) ){
			preg_match('/^([0-9a-z!%]+)([\-\+\*\/]*[0-9a-z!%\.]*)$/D',str_replace('%2B','+',$wert),$berechnen);
			array_walk($berechnen,array('Dekaden_Analyse','MakrosErsetzen'));
				if ( isset($berechnen[2]) && strlen($berechnen[2]) > 0 ){
				$operator = substr($berechnen[2],0,1);
				$berechnen[2] = substr($berechnen[2],1);
					if ( $operator === '+' )
					$berechnen[0] = doubleval($berechnen[1])+doubleval($berechnen[2]);
					elseif ( $operator === '-' )
					$berechnen[0] = doubleval($berechnen[1])-doubleval($berechnen[2]);
					elseif ( $operator === '*' )
					$berechnen[0] = doubleval($berechnen[1])*doubleval($berechnen[2]);
					elseif ( $operator === '/' )
					$berechnen[0] = doubleval($berechnen[1])/doubleval($berechnen[2]);
				}
				if ( !isset($berechnen[0]) )
				$berechnen[0] = $wert;
				if ( $einstellungen['grafik']['pixelgenau'] && strlen($schluessel) <= 2 )
				$berechnen[0] += 0.5;
			$attribute[$schluessel] = $berechnen[0];
			}
		}
		$selektor = $gruppe.' '.$element;
			if ( $einstellungen['grafik']['stile_direkt_einfuegen'] && isset($this->svg_stilvorlagen[$selektor]) ){
				if ( !isset($attribute['style']) )
				$attribute['style'] = $this->svg_stilvorlagen[$selektor];
				else
				$attribute['style'] .= $this->svg_stilvorlagen[$selektor];
				if ( isset($attribute['class']) ){
				$selektor .= '.'.$attribute['class'];
					if ( isset($this->svg_stilvorlagen[$selektor]) )
					$attribute['style'] .= $this->svg_stilvorlagen[$selektor];
				unset($attribute['class']);
				}
			}
		switch ( $element ){
		case 'line':
		$warteschlange[$gruppe][] = '<line '.$this->SchluesselWertNachString($attribute).' />';
		break;
		case 'rect':
		$warteschlange[$gruppe][] = '<rect '.$this->SchluesselWertNachString($attribute).' />';
		break;
		case 'circle':
		$warteschlange[$gruppe][] = '<circle '.$this->SchluesselWertNachString($attribute).' />';
		break;
		case 'text':
		$warteschlange[$gruppe][] = '<text '.$this->SchluesselWertNachString($attribute).'>'.$daten.'</text>';
		break;
		}
	$this->KonsolenAusgabe(__FUNCTION__.'() element='.$gruppe.':'.$wert.' attr='.preg_replace('/[\x00-\x1f]+/','',$attribute_roh),3);
	return true;
	}

	public function VektorGrafikZeichnen($kommentar){
	global $einstellungen;
	// Die Gruppen werden in dieser Reihenfolge gezeichnet. Vorhandenes wird übermalt.
	$gruppen = array('leinwand','kopf-ueberschrift','kopf-info','fuss','legende','legende-zusatz',
	'y-achse-aussen','y-achse-innen','x-achse-aussen','x-achse-innen',
	'diagramm-balken','diagramm-werte-zeigen','diagramm-werte','dynamisch');
//		$gruppen = array('x-achse-innen');
	$puffer = '<?xml version="1.0" encoding="UTF-8"?>
	<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">
	<svg xmlns="http://www.w3.org/2000/svg"
	  xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:ev="http://www.w3.org/2001/xml-events"
	  version="1.1" baseProfile="full" contentStyleType="text/css"
	  width="'.intval($einstellungen['grafik']['breite']).'px" height="'.intval($einstellungen['grafik']['hoehe']).'px">
		  <desc>'.$kommentar.'</desc>
		  <defs>
		    <script type="text/javascript"><![CDATA[
		    function DynTextAnzeigen(a){
		    document.getElementById("dynamische-textbox").textContent = a;
		    }
		    function DynTextLoeschen(){
		    document.getElementById("dynamische-textbox").textContent = "";
		    }
		    ]]>
		    </script>';
		    $puffer .= '
		    <style type="text/css">
		    <![CDATA[
		    '.$einstellungen['grafik']['stile_zusaetzliche_definitionen'];
		    if ( !$einstellungen['grafik']['stile_direkt_einfuegen'] ){
		    $puffer .= '
		    svg { font-family:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftart_normal']).'; }
		    g#kopf-ueberschrift { font-family:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftart_ueberschrift']).';font-size:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftgroesse_ueberschrift_gross']).'; }
		    g#kopf-info { font-family:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftart_ueberschrift']).';font-size:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftgroesse_ueberschrift_klein']).';text-shadow:1px 1px 2px #aaa; }
		    g#fuss { font-size:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftgroesse_normal']).';opacity:0.75; }
		    g#legende rect { stroke:black;stroke-width:1px; }
		    g#legende text { font-size:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftgroesse_normal']).'; }
		    g#legende-zusatz text { font-size:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftgroesse_normal']).'; }
		    g#y-achse-aussen line { stroke:black;stroke-width:1px; }
		    g#y-achse-aussen text { font-size:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftgroesse_y_achse']).'; }
		    g#y-achse-innen line { stroke:gray;stroke-width:0.25px; }
		    g#y-achse-innen .dick { stroke:black;stroke-width:0.75px; }
		    g#y-achse-innen .nullinie { stroke:black;stroke-width:3px; }
		    g#x-achse-aussen line { stroke:black;stroke-width:1px; }
		    g#x-achse-aussen .gross { font-size:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftgroesse_x_achse_gross']).'; }
		    g#x-achse-aussen .klein { font-size:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftgroesse_x_achse_klein']).'; }
		    g#x-achse-innen line { stroke:black;stroke-width:1px; }
		    g#x-achse-innen .dick { stroke:black;stroke-width:1px; }
		    g#diagramm-balken rect { stroke:black;stroke-width:0.5px; }
		    g#diagramm-balken rect:hover { opacity:1; }
		    g#diagramm-balken circle { stroke:black;stroke-width:0.5px; }
		    g#diagramm-werte-zeigen { stroke:none;opacity:0.33; }
		    g#diagramm-werte { font-family:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftart_festbreite']).';font-size:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftgroesse_werte_zeigen']).'; }
		    g#dynamisch text { font-family:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftart_festbreite']).';font-size:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftgroesse_gross']).'; }';
			foreach ( $einstellungen['grafik']['diagramm_balken_daten'] as $balken_schluessel=>$balken_name ){
			$balken_name = explode(',',$balken_name);
			$puffer .= '    .cfill'.$balken_schluessel.' { fill:'.$this->VektorGrafikCSSSaeubern($balken_name[1]).'; }'.chr(10);
			}
		    }
		    $puffer .= '
		    ]]>
		    </style>
		    <linearGradient id="bg-gradient" y1="0%" y2="100%">
		    <stop offset="0%" stop-color="rgb(250,250,250)" />
		    <stop offset="100%" stop-color="rgb(180,180,180)" />
		    </linearGradient>
		  </defs>
	';
	$puffer = str_replace(chr(9),'',$puffer);
	$this->VektorGrafikPuffer('dynamisch','text','id=dynamische-textbox,x=%w/5,y=!!-8','');
	$elemente = $this->VektorGrafikPuffer('','%',null,null);
		foreach ( $gruppen as $gruppe ){
			if ( !isset($elemente[$gruppe]) )
			continue;
		$puffer .= '  <g id="'.$gruppe.'">'.chr(10);
			foreach ( $elemente[$gruppe] as $element )
			$puffer .= '    '.$element.chr(10);
		$puffer .= '  </g>'.chr(10);
		}
	$puffer .= '</svg>';
	$groesse = file_put_contents($einstellungen['grafik']['ausgabe_datei_maske'],$puffer);
	$this->KonsolenAusgabe(__FUNCTION__.'() filesize='.$groesse,3);
	return true;
	}

}
?>
